dp Codeforces 429B B. Working out

B. Working out
time limit per test
 2 seconds
memory limit per test
 256 megabytes
input
 standard input
output
 standard output

Summer is coming! It's time for Iahub and Iahubina to work out, as they both want to look hot at the beach. The gym where they go is a matrix a with n lines and m columns. Let number a[i][j] represents the calories burned by performing workout at the cell of gym in the i-th line and the j-th column.

Iahub starts with workout located at line 1 and column 1. He needs to finish with workout a[n][m]. After finishing workout a[i][j], he can go to workout a[i + 1][j] or a[i][j + 1]. Similarly, Iahubina starts with workout a[n][1] and she needs to finish with workout a[1][m]. After finishing workout from cell a[i][j], she goes to either a[i][j + 1] or a[i - 1][j].

There is one additional condition for their training. They have to meet in exactly one cell of gym. At that cell, none of them will work out. They will talk about fast exponentiation (pretty odd small talk) and then both of them will move to the next workout.

If a workout was done by either Iahub or Iahubina, it counts as total gain. Please plan a workout for Iahub and Iahubina such as total gain to be as big as possible. Note, that Iahub and Iahubina can perform workouts with different speed, so the number of cells that they use to reach meet cell may differs.

Input

The first line of the input contains two integers n and m (3 ≤ n, m ≤ 1000). Each of the next n lines contains m integers: j-th number from i-th line denotes element a[i][j] (0 ≤ a[i][j] ≤ 105).

Output

The output contains a single number — the maximum total gain possible.

Sample test(s)
input
3 3
100 100 100
100 1 100
100 100 100
output
800
Note

Iahub will choose exercises a[1][1] → a[1][2] → a[2][2] → a[3][2] → a[3][3]. Iahubina will choose exercises a[3][1] → a[2][1] → a[2][2] → a[2][3] → a[1][3].

题意:

有一个n*m的矩阵,每个点有一个value,现在A站在位置(1,1)处,他只能向右或者向下走到点(n,m)处,B站在位置(n,1)处,他能向右或者向下走到点(1,m)处,两人的速度不一样,走到的格子可以获得该格子上面的value,但是两人相遇的位置上的value两人都不能拿。现在问两人最终能得到的value的和的最大值。

分析:

乱搞dp。没什么套路,预处理四个角到每个点的最大值。然后枚举每个点当作A和B相遇的点求出最大值就可以了。但是我们注意到,肯定是只有一个相遇点时值最大,所以我们可以想到,一定是1,3角横着或者竖着穿过点(i,j).

嗯,角是这样分布的

       1  4

       2  3



#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>

using namespace std;

#define LL long long

int const maxn = 1100;
int a[maxn][maxn];
LL dp[5][maxn][maxn];
//dp[1][i][j]表示的是从第一个角到点(i,j)经过值的最大和

int main()
{
    int n,m;
    while(scanf("%d%d",&n,&m)==2)
    {
        memset(a,0,sizeof(a));
        for(int i = 1 ; i <= n ; i++)
        {
            for(int j = 1 ; j <= m ; j++)
            {
                scanf("%d",&a[i][j]);
            }
        }
        memset(dp,0,sizeof(dp));
        for(int i = 1 ; i <= n ; i++)
        {
            for(int j = 1 ; j <= m ; j++)
            {
                dp[1][i][j] = max(dp[1][i-1][j] , dp[1][i][j-1]) + a[i][j] ;
            }
            for(int j = m ; j >=1 ; j--)
            {
                dp[4][i][j] = max(dp[4][i-1][j] , dp[4][i][j+1]) + a[i][j] ;
            }
        }
        for(int i = n ; i >= 1 ; i--)
        {
            for(int j = 1 ; j <= m ; j++)
            {
                dp[2][i][j] = max(dp[2][i+1][j] , dp[2][i][j-1]) + a[i][j] ;
            }
            for(int j = m ; j >=1 ; j--)
            {
                dp[3][i][j] = max(dp[3][i+1][j] , dp[3][i][j+1]) + a[i][j] ;
                //cout<<dp[3][i][j]<<endl;
            }

        }
        LL ans = 0 ;
        //不用管边界的情况,都是0,加上也是可以的
        for(int i = 2 ; i < n ; i++)
        {
            for(int j = 2 ; j < m ; j++)
            {
                //枚举每个点当作唯一的交点
                //只有两种情况,1,3角横着或者竖着穿过点(i,j),这样才能保证只有一个交点
                LL num1 = (dp[1][i-1][j]+dp[3][i+1][j]) + (dp[2][i][j-1]+dp[4][i][j+1]);
                //cout<<" "<<dp[1][i-1][j]<<" "<<dp[3][i+1][j]<<" "<<dp[2][i][j-1]<<" "<<dp[4][i][j+1]<<endl;
                //cout<<num1<<endl;
                ans = max(ans,num1);
                LL num2 = (dp[1][i][j-1]+dp[3][i][j+1]) + (dp[2][i+1][j]+dp[4][i-1][j]);
                ans = max(ans,num2);
                //cout<<" "<<dp[1][i][j-1]<<" "<<dp[3][i][j+1]<<" "<<dp[2][i+1][j]<<" "<<dp[3][i-1][j]<<endl;
                //cout<<num2<<endl;
            }
        }
        printf("%I64d\n",ans);
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值